#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_SphereBmp"
#define MYWNDCLASS		"CLASS_DX9_SphereBmp"
#define WIDTH			256 			// ʂ̉̃TCY
#define HEIGHT			256 			// ʂ̏c̃TCY
#define SAFE_RELEASE(p) if (p){p->Release();p=NULL;}

inline DWORD F2DW( FLOAT f ) { return *((DWORD*)&f); }

struct BUMPVERTEX			// Y_tH[}bg̒`
{
	D3DXVECTOR3 v;			// W
	float		tu1,tv1;	// eNX`W1
	float		tu2,tv2;	// eNX`W2
};
#define FVF_BUMPVERTEX (D3DFVF_XYZ | D3DFVF_TEX2)

struct BACKGROUNDVERTEX 	// wi_tH[}bg̒`
{
	D3DXVECTOR4 v;			// W
	D3DCOLOR	color;		// F
	float		tu,tv;		// eNX`W
};
#define FVF_BACKGROUNDVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPDIRECT3DTEXTURE9		g_psBumpMap = NULL; 		// The actual bumpmap
LPDIRECT3DTEXTURE9		g_pTexBackground = NULL;	// eNX`(wi)
LPDIRECT3DVERTEXBUFFER9 g_pBackgroundVB = NULL;
LPDIRECT3DVERTEXBUFFER9 g_pLensVB = NULL;
bool					g_flagFile = true;			// \[X摜tOifalse:쐬Atrue:t@Cj

HRESULT InitD3D(HWND hWnd);
void	InitGeometry();
void	SetupMatrices();
void	Draw_Main();
void	Draw_Model();
HRESULT CreateBumpMap( UINT iWidth, UINT iHeight );
void	Save_Bmp();
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(__argc <= 1){
			MessageBox(hWnd, "Btimap t@C Drag & Drop pł", MYWNDTITLE, 0);
			SendMessage(hWnd, WM_CLOSE, 0, 0);
		}
		if(FAILED( InitD3D(hWnd) )){
			MessageBox(hWnd, "D3D9̏Ɏs܂", MYWNDTITLE, 0);
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			return 0;
		}
		break;
		
	case WM_SIZE:
		Draw_Main();
		Save_Bmp();
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
		case VK_ESCAPE: 		// [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		DestroyWindow(hWnd);
		Cleanup();				// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	DWORD	dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_CAPTION | WS_VISIBLE;
	RECT	rc = {0, 0, WIDTH, HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
				NULL,
				NULL,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	g_d3dpp.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;  // obNobt@̎擾\ɂ
	
	// D3D9Device 쐬
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
			return E_FAIL;
		}
	}
	
	// ݒ
	InitGeometry();
	
	return S_OK;
}//InitD3D

// ݒ̏
void InitGeometry()
{
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// eNX` tB^ݒ
	g_pD3DDev->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
	g_pD3DDev->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
	g_pD3DDev->SetSamplerState( 1, D3DSAMP_ADDRESSU,  D3DTADDRESS_CLAMP );
	g_pD3DDev->SetSamplerState( 1, D3DSAMP_ADDRESSV,  D3DTADDRESS_CLAMP );
	g_pD3DDev->SetSamplerState( 1, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
	g_pD3DDev->SetSamplerState( 1, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
	g_pD3DDev->SetSamplerState( 1, D3DSAMP_MIPFILTER, D3DTEXF_NONE );
	// eNX`쐬
	D3DXCreateTextureFromFile(g_pD3DDev, __argv[1], &g_pTexBackground);
	// ov}bv
	CreateBumpMap( 256, 256 );
	// _obt@쐬
	g_pD3DDev->CreateVertexBuffer( 4*sizeof(BACKGROUNDVERTEX), D3DUSAGE_WRITEONLY, FVF_BACKGROUNDVERTEX,
									D3DPOOL_MANAGED, &g_pBackgroundVB, NULL );
	
	BACKGROUNDVERTEX* vBackground;
	g_pBackgroundVB->Lock( 0, 0, (void**)&vBackground, 0 );
	for( UINT i=0; i<4; i ++ )
	{
		vBackground[i].v = D3DXVECTOR4( 0.0f, 0.0f, 0.999999f, 1.0f );
		vBackground[i].color = 0xffffffff;
	}
	vBackground[0].v.y = (FLOAT) HEIGHT;
	vBackground[2].v.y = (FLOAT) HEIGHT;
	vBackground[2].v.x = (FLOAT) WIDTH;
	vBackground[3].v.x = (FLOAT) WIDTH;
	vBackground[0].tu = 0.0f; vBackground[0].tv = 1.0f;
	vBackground[1].tu = 0.0f; vBackground[1].tv = 0.0f;
	vBackground[2].tu = 1.0f; vBackground[2].tv = 1.0f;
	vBackground[3].tu = 1.0f; vBackground[3].tv = 0.0f;
	g_pBackgroundVB->Unlock();
	
	g_pD3DDev->CreateVertexBuffer( 4*sizeof(BUMPVERTEX),D3DUSAGE_WRITEONLY, FVF_BUMPVERTEX,
									D3DPOOL_MANAGED, &g_pLensVB, NULL );
	BUMPVERTEX* vLens;
	g_pLensVB->Lock( 0, 0, (void**)&vLens, 0 );
	vLens[0].v = D3DXVECTOR3(-256.0f,-256.0f, 0.0f );
	vLens[1].v = D3DXVECTOR3(-256.0f, 256.0f, 0.0f );
	vLens[2].v = D3DXVECTOR3( 256.0f,-256.0f, 0.0f );
	vLens[3].v = D3DXVECTOR3( 256.0f, 256.0f, 0.0f );
	vLens[0].tu1 = 0.0f; vLens[0].tv1 = 1.0f;
	vLens[1].tu1 = 0.0f; vLens[1].tv1 = 0.0f;
	vLens[2].tu1 = 1.0f; vLens[2].tv1 = 1.0f;
	vLens[3].tu1 = 1.0f; vLens[3].tv1 = 0.0f;
	g_pLensVB->Unlock();
	// _tH[}bgݒ
	g_pD3DDev->SetVertexShader(NULL);
	// ϊsݒ
	SetupMatrices();
}// InitGeometry

// ϊs̐ݒ
void SetupMatrices()
{
	// r[s
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0,-620.0f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// vWFNVs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,1.0f,3000.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
}// SetupMatrices

// `
void Draw_Main()
{	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if( SUCCEEDED( g_pD3DDev->BeginScene() ) )
	{
		Draw_Model();	// f`
		
		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture( 0, NULL );
		g_pD3DDev->SetTexture( 1, NULL );
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// f`
void Draw_Model()
{
	// Render the background
	g_pD3DDev->SetTexture( 0, g_pTexBackground );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
	g_pD3DDev->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );

	g_pD3DDev->SetFVF( FVF_BACKGROUNDVERTEX );
	g_pD3DDev->SetStreamSource( 0, g_pBackgroundVB, 0, sizeof(BACKGROUNDVERTEX) );
	g_pD3DDev->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );
	
	g_pD3DDev->SetTexture( 0, g_psBumpMap );
	g_pD3DDev->SetTexture( 1, g_pTexBackground );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_BUMPENVMAP );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_CURRENT );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_BUMPENVMAT00, F2DW(0.2f) );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_BUMPENVMAT01, F2DW(0.0f) );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_BUMPENVMAT10, F2DW(0.0f) );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_BUMPENVMAT11, F2DW(0.2f) );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_BUMPENVLSCALE, F2DW(1.0f) );
	g_pD3DDev->SetTextureStageState( 0, D3DTSS_BUMPENVLOFFSET, F2DW(0.0f) );
	g_pD3DDev->SetTextureStageState( 1, D3DTSS_COLOROP, D3DTOP_SELECTARG1 );
	g_pD3DDev->SetTextureStageState( 1, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	g_pD3DDev->SetTextureStageState( 1, D3DTSS_COLORARG2, D3DTA_CURRENT );
	
	// Generate texture coords depending on objects camera space position
	D3DXMATRIX mat;
	mat._11 = 0.41f; mat._12 = 0.0f;
	mat._21 = 0.0f; mat._22 =-0.41f;
	mat._31 = 0.0f; mat._32 = 0.0f;
	mat._41 = 0.5f; mat._42 = 0.5f;

	// Scale-by-z here
	D3DXMATRIX	matView, matProj;
	g_pD3DDev->GetTransform( D3DTS_VIEW,	   &matView );
	g_pD3DDev->GetTransform( D3DTS_PROJECTION, &matProj );
	D3DXVECTOR3 vEyePt( matView._41, matView._42, matView._43 );
	FLOAT		z = D3DXVec3Length( &vEyePt );
	mat._11 *= ( matProj._11 / ( matProj._33 * z + matProj._34 ) );
	mat._22 *= ( matProj._22 / ( matProj._33 * z + matProj._34 ) );

	g_pD3DDev->SetTransform( D3DTS_TEXTURE1, &mat );
	g_pD3DDev->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
	g_pD3DDev->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEPOSITION | 1);

	//	Render the lens
	g_pD3DDev->SetFVF( FVF_BUMPVERTEX );
	g_pD3DDev->SetStreamSource( 0, g_pLensVB, 0, sizeof(BUMPVERTEX) );
	g_pD3DDev->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );

}// Draw_Model

HRESULT CreateBumpMap( UINT iWidth, UINT iHeight )
{
	SAFE_RELEASE(g_psBumpMap);
	// Create the bumpmap's surface and texture objects
	if( FAILED( g_pD3DDev->CreateTexture( iWidth, iHeight, 1, 0,
		D3DFMT_V8U8, D3DPOOL_MANAGED, &g_psBumpMap, NULL ) ) )
	{
		return E_FAIL;
	}

	// Fill the bumpmap texels to simulate a lens
	D3DLOCKED_RECT d3dlr;
	g_psBumpMap->LockRect( 0, &d3dlr, 0, 0 );
	UINT  mid		 = iWidth/2;

	for( DWORD y0 = 0; y0 < iHeight; y0++ )
	{
		CHAR* pDst = (CHAR*)d3dlr.pBits + y0*d3dlr.Pitch;

		for( DWORD x0 = 0; x0 < iWidth; x0++ )
		{
			DWORD x1 = ( (x0==iWidth-1)  ? x0 : x0+1 );
			DWORD y1 = ( (x0==iHeight-1) ? y0 : y0+1 );

			FLOAT fDistSq00 = (FLOAT)( (x0-mid)*(x0-mid) + (y0-mid)*(y0-mid) );
			FLOAT fDistSq01 = (FLOAT)( (x1-mid)*(x1-mid) + (y0-mid)*(y0-mid) );
			FLOAT fDistSq10 = (FLOAT)( (x0-mid)*(x0-mid) + (y1-mid)*(y1-mid) );

			FLOAT v00 = ( fDistSq00 > (mid*mid) ) ? 0.0f : sqrtf( (mid*mid) - fDistSq00 );
			FLOAT v01 = ( fDistSq01 > (mid*mid) ) ? 0.0f : sqrtf( (mid*mid) - fDistSq01 );
			FLOAT v10 = ( fDistSq10 > (mid*mid) ) ? 0.0f : sqrtf( (mid*mid) - fDistSq10 );

			FLOAT iDu = (128/D3DX_PI)*atanf(v00-v01); // The delta-u bump value
			FLOAT iDv = (128/D3DX_PI)*atanf(v00-v10); // The delta-v bump value

			*pDst++ = (CHAR)(iDu);
			*pDst++ = (CHAR)(iDv);
		}
	}

	g_psBumpMap->UnlockRect(0);

	return S_OK;
}

// rbg}bvۑ
void Save_Bmp()
{
	LPDIRECT3DSURFACE9	pD3DBack = NULL;	// obNobt@̃sNZl
	HDC 				hDC, hDCCompat;
	HBITMAP 			hBmp = NULL,hBmpPrev;
	BITMAPINFO			pbmi;
	RECT				rc;
	
	// DIB 擾
	GetClientRect(GetFocus(), &rc);
	g_pD3DDev->GetBackBuffer(0,0,D3DBACKBUFFER_TYPE_MONO,&pD3DBack);
	pD3DBack->GetDC(&hDC);
	ZeroMemory(&pbmi, sizeof(pbmi));
	pbmi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	pbmi.bmiHeader.biWidth = rc.right;
	pbmi.bmiHeader.biHeight = rc.bottom;
	pbmi.bmiHeader.biBitCount = 24;
	pbmi.bmiHeader.biPlanes = 1;
	hBmp = CreateDIBSection(hDC, &pbmi, DIB_RGB_COLORS, NULL, NULL, 0);
	hDCCompat = CreateCompatibleDC(hDC);
	hBmpPrev = (HBITMAP)SelectObject(hDCCompat, hBmp);
	BitBlt(hDCCompat, 0, 0, pbmi.bmiHeader.biWidth, pbmi.bmiHeader.biHeight,
				hDC, 0, 0, SRCCOPY);
	SelectObject(hDCCompat, hBmpPrev);
	pD3DBack->ReleaseDC(hDC);
	SAFE_RELEASE(pD3DBack);
	DIBSECTION			Dib;
	HANDLE				hFile;
	DWORD				dwWrite;
	BITMAPFILEHEADER	bmfh;
	int 				size_pbits,size_pbmi;
	GetObject(hBmp, sizeof(DIBSECTION), &Dib);
	size_pbmi  = sizeof(BITMAPINFOHEADER);
	size_pbits = Dib.dsBm.bmWidthBytes * Dib.dsBm.bmHeight;
	ZeroMemory(&bmfh, sizeof(BITMAPFILEHEADER));
	bmfh.bfType = 0x4d42;
	bmfh.bfOffBits = sizeof(bmfh) + size_pbmi;
	bmfh.bfSize = bmfh.bfOffBits + size_pbits;
	char	*p;
	p = strrchr(__argv[1], '.');
	if(p){
		strcpy(p, "_new.bmp");
	}
	else{
		strcat(p, "_new.bmp");
	}
	hFile = CreateFile(__argv[1], GENERIC_WRITE, FILE_SHARE_WRITE,
						NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	WriteFile(hFile, &bmfh, sizeof(BITMAPFILEHEADER), &dwWrite, NULL);
	WriteFile(hFile, &Dib.dsBmih, size_pbmi, &dwWrite, NULL);
	WriteFile(hFile, Dib.dsBm.bmBits, size_pbits, &dwWrite, NULL);
	CloseHandle(hFile);
	DeleteObject(hBmp);
}// Save_Bmp

// IuWFNg̉
void Cleanup()
{
	// Direct3D IuWFNg
	SAFE_RELEASE(g_psBumpMap);
	SAFE_RELEASE(g_pTexBackground);
	SAFE_RELEASE(g_pLensVB);
	SAFE_RELEASE(g_pBackgroundVB);
	SAFE_RELEASE(g_pD3DDev);
	SAFE_RELEASE(g_pD3D);
}// Cleanup
